#include <cstdio>
#include <armadillo>

#include "Processor.hpp"
#include "NullSource.hpp"
#include "NullSink.hpp"
#include "TestBlock.hpp"


#ifndef LENGTH
#define LENGTH(a) (sizeof(a)/sizeof(a[0]))
#endif

const size_t BUFSIZE = 16;

int test02()
{
	Processor processor;
	NullSource<double> nullSrc(BUFSIZE);
	NullSink<double> nullSink(BUFSIZE);
	TestBlock testblock(BUFSIZE);

	nullSrc.addBuffer(testblock.buffer());
	testblock.addBuffer(nullSink.buffer());

	processor.blockAdd(nullSrc);
	processor.blockAdd(testblock);
	processor.blockAdd(nullSink);

	processor.run();

	return 0;
}